9999 4999
h
i
h
d
k
k
e
f
c
b
g
f
c
c
f
d
i
g
i
h
g
d
k
c
g
j
g
e
f
h
b
h
i
c
j
h
b
h
c
d
b
f
g
h
f
h
i
g
f
h
e
j
i
j
j
k
b
g
i
d
d
c
c
e
h
k
c
g
b
j
g
k
b
c
i
d
g
d
h
b
g
k
i
e
b
k
b
g
i
j
h
d
h
e
d
f
g
d
j
h
e
f
j
f
h
k
d
h
d
j
c
b
c
e
j
k
f
b
g
i
j
j
d
f
d
g
i
c
c
e
j
e
i
e
g
b
d
c
h
e
g
j
j
b
j
c
j
k
b
k
g
j
d
g
h
d
e
h
j
e
e
k
c
g
c
e
j
e
d
k
j
j
f
c
b
d
h
j
e
h
k
c
e
f
d
j
g
b
b
k
e
k
i
k
e
b
h
g
g
f
j
c
c
b
f
k
d
h
k
d
c
g
h
g
d
g
i
d
i
d
k
e
e
k
d
g
d
b
f
j
d
k
f
g
j
h
k
d
k
f
j
f
f
b
j
i
h
h
j
b
g
i
f
d
j
k
d
d
j
f
d
c
f
g
c
g
d
i
j
g
b
e
i
i
j
e
g
f
c
f
e
e
d
e
h
g
d
h
i
h
g
j
h
f
c
i
c
e
c
g
k
g
k
e
e
i
c
j
g
f
c
d
d
k
c
k
f
i
g
e
k
i
d
g
g
j
c
k
g
b
e
d
h
j
i
k
k
d
f
j
e
f
e
h
f
g
b
i
d
h
f
g
h
j
b
d
d
d
d
d
g
d
f
g
b
e
c
j
f
g
e
f
e
d
g
h
g
g
i
b
e
j
b
g
c
f
d
g
j
h
g
c
b
g
b
i
b
g
d
f
k
k
i
b
c
h
f
f
g
k
j
c
h
e
c
f
k
d
h
g
b
d
d
g
b
c
d
i
k
f
k
c
b
b
h
k
j
e
b
b
k
j
j
i
i
f
k
d
e
e
f
b
g
k
e
f
f
d
d
e
d
f
h
c
b
j
h
j
d
e
c
g
g
i
k
f
k
f
g
b
k
c
j
e
d
j
c
g
d
f
j
g
h
h
c
h
e
f
h
e
k
e
j
e
j
d
d
b
f
g
e
g
h
b
i
h
e
c
k
j
d
f
k
g
k
g
c
h
b
e
h
h
d
d
e
g
g
f
h
g
i
b
f
f
b
k
b
g
c
j
d
i
c
h
b
h
e
d
h
b
g
e
c
e
j
j
i
f
b
e
k
c
f
e
f
g
k
b
e
f
c
c
f
b
i
b
h
d
k
c
e
h
i
e
k
j
h
b
d
h
k
i
i
k
g
g
g
c
b
g
d
d
d
b
b
j
j
g
j
k
g
g
g
c
c
h
e
e
j
i
e
e
g
b
e
f
b
d
h
i
j
d
i
h
e
j
j
i
k
i
i
e
f
k
b
d
f
i
g
f
i
k
e
c
d
h
b
c
e
g
c
h
k
k
e
j
f
h
f
g
i
c
e
g
k
f
e
d
b
e
g
f
i
f
j
i
f
f
j
h
j
c
j
k
j
j
i
h
c
h
h
j
j
j
e
d
i
g
e
h
g
h
e
f
h
d
f
h
e
e
i
k
e
b
f
i
k
e
j
j
j
k
e
c
g
j
d
j
g
h
h
i
e
j
g
j
d
d
h
d
d
j
e
j
h
k
k
b
j
c
b
e
f
k
f
i
g
i
f
f
g
d
g
g
j
g
i
b
j
g
e
j
e
d
d
g
k
k
c
i
h
d
c
c
i
i
b
k
d
b
b
f
h
f
g
c
d
h
b
j
h
k
d
i
i
j
j
c
f
k
e
e
k
j
b
h
c
h
d
j
j
b
e
g
h
c
c
g
c
c
b
j
d
h
e
k
g
e
e
c
j
j
c
i
j
f
c
b
i
k
c
h
i
i
k
e
i
e
b
g
f
g
e
c
e
g
g
g
j
e
h
b
h
g
d
e
h
j
c
j
e
i
b
k
e
j
h
i
b
k
k
j
h
f
c
h
i
i
k
d
h
e
i
f
k
d
g
f
e
b
k
h
h
g
d
k
i
j
k
i
f
k
i
k
h
i
i
i
j
d
g
k
j
f
e
d
h
h
h
g
e
d
k
e
h
g
d
c
c
b
d
e
e
e
b
g
j
h
k
h
i
b
i
d
e
h
j
d
e
b
i
i
g
c
j
i
g
b
g
d
h
h
i
j
j
d
c
k
k
f
j
j
b
e
h
i
c
g
h
h
e
d
f
c
c
f
g
b
i
f
i
g
f
d
d
h
k
f
j
f
e
b
j
k
h
d
i
i
j
h
j
h
g
f
d
i
k
e
e
c
i
c
e
h
g
h
j
f
c
e
e
b
i
e
h
i
e
j
f
j
f
d
h
g
i
f
k
e
c
c
b
i
g
f
c
i
k
c
b
h
i
h
i
b
d
g
e
c
d
d
e
k
g
c
h
k
d
h
b
i
d
f
f
k
k
i
k
b
g
j
f
e
j
i
f
e
f
d
d
d
j
g
j
f
j
e
g
e
c
j
g
g
g
c
k
i
d
e
i
f
d
g
d
e
b
f
h
h
g
b
b
c
g
k
i
c
j
c
j
h
e
e
c
e
g
e
b
g
i
j
e
c
k
b
h
i
h
b
k
i
b
c
k
d
d
h
i
b
e
k
k
j
d
c
b
g
c
h
j
h
d
h
k
i
g
i
h
j
k
g
g
e
j
h
c
j
k
j
i
i
j
i
k
j
b
g
b
f
k
f
g
h
f
b
g
c
h
i
k
b
h
e
e
j
g
e
e
j
g
i
h
d
h
f
i
j
h
f
g
d
i
k
j
b
f
i
e
i
b
b
d
j
d
d
i
i
j
k
i
i
i
f
f
i
e
g
c
e
h
d
e
b
b
d
g
j
e
k
i
f
e
e
b
j
k
h
i
e
c
g
g
h
k
f
b
b
e
g
j
i
f
j
b
j
g
i
k
k
g
e
k
c
d
c
h
b
i
h
k
h
e
g
f
d
j
i
j
d
k
e
d
h
k
i
j
h
g
e
i
g
j
f
f
g
d
i
b
c
c
g
e
k
g
g
g
c
g
h
k
h
f
k
g
j
k
k
d
k
j
b
j
i
b
h
i
g
k
b
d
f
f
f
i
c
g
f
b
d
d
h
g
e
c
k
k
d
j
j
h
h
g
k
f
b
b
h
f
g
j
j
b
b
j
h
f
b
g
e
i
e
e
i
c
f
d
i
f
j
j
g
j
d
d
j
b
i
c
j
d
b
d
j
b
e
k
e
e
f
b
j
f
i
d
g
d
i
j
h
i
b
g
e
c
c
d
d
i
j
i
k
j
e
h
c
h
j
c
k
j
j
c
f
i
e
k
c
d
d
b
f
e
k
i
f
i
h
i
g
g
j
h
g
c
j
f
k
b
d
h
f
b
b
e
c
b
k
e
b
j
e
k
k
i
b
f
e
b
b
b
j
d
j
g
c
k
g
i
b
f
e
d
f
f
d
h
c
f
i
h
g
i
j
h
h
d
b
i
b
d
e
f
i
h
j
g
f
d
g
k
b
h
b
g
c
e
j
g
b
d
h
d
b
h
b
b
h
j
h
c
d
c
i
j
d
k
d
j
k
c
h
c
e
g
e
i
j
f
k
i
g
b
c
j
k
f
g
c
b
f
j
c
j
k
k
h
f
h
d
k
g
i
i
h
c
g
g
h
j
b
i
i
g
j
f
b
g
b
d
h
h
i
g
i
h
g
k
h
i
h
f
g
h
d
g
e
c
b
b
c
h
d
d
c
g
j
f
b
f
f
i
g
j
f
k
g
h
f
c
b
i
d
d
f
c
k
h
g
d
e
d
f
f
e
c
e
k
j
g
b
k
j
h
g
c
j
e
d
f
i
e
h
g
k
j
h
h
e
e
b
i
g
j
h
j
f
f
k
g
g
i
e
h
c
c
f
f
c
d
i
d
j
j
f
b
g
j
h
k
i
d
j
k
e
g
f
b
e
h
c
f
f
b
h
k
j
j
k
i
f
d
c
i
c
c
d
b
d
g
h
g
h
f
b
h
h
d
e
h
c
e
g
b
b
h
i
d
c
h
g
f
f
b
j
b
e
e
b
b
h
j
f
f
i
e
d
i
j
c
g
k
i
j
b
k
d
i
i
c
f
k
b
b
c
h
b
k
i
h
f
b
f
g
k
e
i
h
f
i
f
e
j
f
f
h
e
b
f
i
i
c
c
g
j
h
j
j
k
g
f
b
d
f
k
h
d
j
e
f
f
i
g
d
j
h
d
k
d
e
b
d
c
i
k
f
g
c
k
k
b
h
i
f
b
h
g
c
g
b
e
g
j
j
c
d
i
b
i
i
d
f
b
b
j
h
e
c
g
d
h
d
i
f
j
i
g
g
d
h
e
f
i
i
f
k
c
k
h
k
b
c
c
k
i
h
f
d
c
i
d
d
b
c
c
i
e
f
e
b
k
c
e
c
g
f
j
g
d
d
c
c
i
k
d
h
h
g
b
c
b
e
c
f
j
e
b
i
g
e
k
h
e
g
g
i
i
f
g
k
j
k
i
k
e
b
f
k
h
e
j
k
b
h
e
j
i
e
j
e
e
i
j
j
d
d
j
d
g
i
d
d
e
b
e
c
f
k
j
d
b
i
f
e
k
j
d
b
e
c
j
i
k
c
g
f
h
f
h
f
d
k
e
d
k
j
i
b
h
e
c
d
d
j
e
k
i
e
b
g
j
i
j
j
f
h
e
h
c
h
g
e
k
b
e
h
g
g
h
f
k
h
f
b
e
f
f
e
i
b
k
i
f
e
f
j
e
g
i
j
f
f
b
i
d
c
h
j
b
i
b
h
k
c
e
j
e
k
i
d
j
c
b
g
c
b
b
j
i
j
j
g
i
i
d
g
g
c
f
k
c
k
j
h
i
c
j
c
k
f
h
d
g
d
f
i
i
f
f
k
g
e
b
j
g
d
c
i
e
b
d
k
c
k
i
i
c
i
g
i
k
i
g
c
b
g
c
k
k
b
g
c
j
b
g
k
f
c
b
d
d
d
e
f
f
h
b
i
g
k
d
i
g
b
b
g
i
d
c
e
b
g
h
k
g
g
g
b
i
e
g
b
k
i
i
j
c
k
h
c
h
h
e
g
e
f
c
d
c
e
f
c
g
i
k
b
c
f
k
c
j
g
e
b
e
i
i
g
d
c
e
k
c
h
j
h
b
g
i
k
j
k
k
d
e
i
b
b
h
d
c
k
f
k
e
f
d
k
f
f
g
g
g
f
k
h
j
k
k
h
d
f
g
i
e
c
h
h
h
j
h
e
j
k
h
d
h
b
g
d
k
c
g
f
e
h
j
c
d
g
f
h
c
f
j
g
g
c
b
h
k
j
e
k
e
g
k
c
g
k
d
d
d
f
j
h
g
k
j
i
c
i
g
c
b
i
g
k
e
h
c
d
j
b
f
e
d
g
k
h
i
c
e
h
e
e
h
i
h
g
k
i
d
f
d
e
j
d
h
f
f
e
f
j
k
b
d
g
i
j
k
f
j
j
d
i
c
b
k
h
k
h
f
e
h
e
d
b
h
h
b
g
e
b
d
d
h
i
j
e
f
k
c
c
j
k
b
b
h
e
j
e
e
g
e
i
k
j
c
i
i
j
i
f
j
c
g
e
j
h
g
j
d
e
f
i
j
h
b
h
f
i
b
b
f
g
b
j
c
c
c
h
h
g
j
e
f
i
e
b
e
j
f
f
i
j
i
j
d
b
i
k
h
h
b
k
h
j
j
i
h
c
j
e
b
j
g
f
i
b
e
e
h
k
e
b
k
h
h
j
g
d
g
g
i
d
e
g
k
k
d
c
f
i
k
e
i
f
d
f
b
g
c
h
i
j
d
b
c
k
h
i
f
d
b
i
g
d
c
f
b
k
g
j
k
e
g
i
b
e
c
g
j
k
c
e
h
e
c
i
d
g
k
b
b
f
j
c
h
e
g
e
f
f
i
d
k
d
d
c
c
f
h
c
h
f
g
j
i
e
e
g
g
e
j
c
e
k
h
g
i
k
e
k
e
g
b
b
h
e
i
k
f
g
e
d
g
b
f
k
f
h
i
h
i
e
b
k
j
i
e
f
e
d
f
f
f
j
h
f
j
i
c
b
j
i
j
b
b
g
h
f
g
d
b
b
c
c
h
j
b
d
i
f
k
c
d
k
e
f
k
j
i
h
k
c
d
j
i
d
e
h
b
d
i
j
c
h
e
f
k
b
i
g
i
h
b
f
c
h
e
c
d
d
k
i
j
e
h
k
i
k
g
f
b
f
f
h
k
f
g
b
i
g
j
b
e
h
b
f
f
k
f
k
d
j
h
i
b
h
e
b
i
g
j
d
k
e
i
d
g
b
d
d
j
h
g
i
j
e
e
g
b
g
d
h
c
f
d
j
k
g
b
b
h
k
e
k
c
d
e
k
k
d
f
h
j
f
d
b
d
b
d
h
k
k
b
f
k
k
i
f
d
d
e
b
e
e
b
k
g
i
h
e
f
e
h
j
d
i
g
d
j
d
k
g
i
c
b
b
c
c
j
c
b
g
d
b
k
e
b
j
b
f
k
h
c
j
j
b
b
j
d
h
b
d
j
i
b
c
b
h
i
f
c
j
k
j
j
c
f
k
d
h
e
c
k
i
h
c
e
e
h
j
d
f
d
f
k
g
b
k
e
b
d
f
c
i
e
d
f
d
d
h
g
f
k
j
f
i
b
e
k
f
i
f
i
b
k
h
g
k
c
i
c
f
b
h
h
e
h
g
h
h
g
c
i
j
c
g
h
g
b
g
b
c
c
j
d
i
g
c
h
k
c
c
g
i
j
c
k
c
b
c
d
e
i
i
j
d
c
g
f
f
c
i
e
g
f
b
d
k
k
f
d
k
b
h
j
c
b
d
i
e
e
k
b
f
c
k
g
b
j
c
g
b
b
i
b
j
k
h
g
b
i
i
f
f
e
i
g
f
f
j
c
b
h
h
d
c
f
i
f
b
e
j
f
k
e
d
j
j
k
j
c
e
j
e
c
f
h
f
g
k
i
b
k
j
d
g
d
f
c
f
e
c
k
e
c
i
k
c
i
e
f
f
e
d
b
c
e
k
d
i
g
h
j
h
b
f
j
g
h
h
k
j
j
i
f
e
f
j
h
i
d
g
e
c
f
e
d
d
i
g
d
g
k
j
h
f
k
j
g
e
b
j
h
c
f
d
k
j
j
d
h
g
g
j
f
j
c
j
h
e
c
i
h
e
j
d
c
j
j
e
i
b
g
e
k
i
j
h
h
k
h
d
h
j
b
j
k
g
d
d
d
d
f
g
e
e
b
g
e
h
b
h
b
g
e
c
j
h
f
h
g
i
g
h
b
j
g
g
i
g
h
c
e
f
e
c
j
b
c
e
h
k
f
f
g
e
h
h
e
c
h
b
e
h
e
b
j
i
g
d
f
k
h
j
c
i
f
k
g
d
c
d
k
e
e
k
g
g
c
b
f
k
j
c
j
c
e
d
f
e
i
e
g
f
i
k
b
c
e
i
k
i
c
c
j
j
h
e
i
k
g
g
e
c
g
k
d
j
f
i
b
i
g
g
g
f
f
k
f
e
h
h
b
f
h
g
f
g
g
f
c
b
k
g
d
d
j
f
b
g
e
f
e
g
h
k
f
j
h
f
k
c
k
h
i
e
b
d
g
f
i
k
c
j
e
c
g
c
c
c
d
c
h
k
g
g
c
i
e
e
e
j
k
k
h
g
j
j
e
k
f
e
e
d
e
k
e
i
f
b
g
h
j
h
d
c
f
c
i
g
k
d
j
i
d
f
d
j
k
d
d
g
k
b
b
g
j
j
e
h
f
h
d
k
g
d
c
f
g
j
g
c
c
f
g
j
g
i
b
k
g
k
d
f
g
c
k
h
i
f
d
d
d
b
e
c
k
e
j
c
i
b
k
g
d
f
b
g
i
d
f
k
i
i
e
k
d
d
f
g
k
f
b
j
d
g
b
j
f
e
g
g
i
k
c
d
h
f
d
g
i
k
i
g
i
f
f
e
h
i
g
e
c
b
j
i
d
b
c
g
e
k
c
i
g
g
f
h
d
e
d
g
e
c
c
f
g
j
c
j
k
j
h
h
k
b
c
e
b
i
i
g
i
j
e
f
k
k
j
i
f
g
c
k
j
e
j
b
h
c
g
k
k
j
i
b
j
d
g
c
e
e
j
i
f
j
f
g
d
c
h
h
h
d
g
h
d
i
b
e
j
g
i
j
k
j
b
i
i
h
i
f
d
i
c
b
e
c
g
i
e
i
g
h
j
b
b
d
i
i
j
f
e
e
e
k
k
i
f
k
b
c
j
i
h
e
g
j
i
j
e
d
i
f
b
h
b
g
g
e
i
d
d
j
g
k
h
h
d
f
b
c
e
c
c
e
h
k
k
g
d
c
e
g
e
k
h
e
k
h
k
i
f
e
e
c
e
d
i
e
d
j
g
d
f
i
j
k
f
j
k
c
b
i
h
j
j
g
g
c
e
c
i
b
f
i
c
e
h
i
e
e
d
e
d
e
j
j
h
i
c
e
d
g
c
b
b
i
f
i
f
e
g
c
e
b
d
g
e
g
e
g
k
e
i
i
g
h
b
i
g
f
d
h
g
d
e
j
d
g
k
h
e
h
j
j
e
g
f
k
b
f
i
h
i
e
f
d
g
j
k
e
d
f
c
k
f
i
f
b
g
j
h
f
j
d
e
i
h
d
h
j
k
g
e
d
g
d
i
e
j
j
j
g
e
d
b
k
f
c
k
h
h
j
f
c
j
d
k
b
e
k
i
e
j
c
d
h
k
c
h
d
e
i
e
g
k
g
j
k
b
d
d
j
g
e
k
i
i
d
e
h
i
e
f
c
f
d
g
f
c
j
h
k
f
k
d
d
j
h
k
e
j
i
f
j
e
g
c
k
g
k
e
c
e
e
i
c
g
h
b
b
d
g
k
g
k
d
k
e
k
e
b
b
b
c
g
c
d
d
i
f
g
f
b
h
i
j
h
i
h
j
f
f
j
c
c
j
c
e
k
k
c
b
c
f
c
g
g
e
b
h
b
j
f
c
k
k
k
g
c
g
f
d
e
f
e
h
g
i
k
i
c
b
i
f
j
b
f
b
k
c
d
h
i
g
g
f
k
g
k
e
g
j
f
k
j
b
j
c
b
j
g
h
i
c
c
c
d
c
c
c
e
e
k
f
e
b
h
f
b
f
c
b
j
b
c
i
e
f
c
i
c
h
g
k
e
e
b
i
e
b
g
g
b
b
b
j
i
g
i
b
i
e
k
i
g
c
b
d
h
b
h
e
i
h
b
g
j
f
e
j
c
h
j
f
c
f
c
e
g
d
f
j
k
i
c
c
b
f
f
k
i
d
h
e
f
c
h
j
f
j
b
d
k
d
c
i
h
h
h
h
j
b
k
d
i
h
g
c
h
g
h
k
c
h
k
g
f
g
f
d
h
i
f
g
k
g
f
e
f
c
e
b
f
k
g
e
g
g
f
j
b
h
c
c
e
k
d
e
g
i
j
h
e
j
k
f
g
e
j
j
c
g
c
h
g
i
f
d
b
j
k
c
i
c
c
d
h
c
j
g
k
j
k
k
i
e
e
g
b
e
e
f
b
g
e
i
k
d
j
f
g
f
h
k
g
b
j
h
d
d
h
i
i
j
j
i
e
f
d
i
k
c
j
d
i
b
b
d
d
k
i
h
f
k
e
d
c
f
e
h
c
e
e
h
d
f
i
e
b
h
b
i
j
b
d
d
b
k
c
g
f
e
f
j
e
f
j
b
f
b
j
d
k
i
g
j
g
d
h
j
k
d
i
c
e
h
g
j
c
e
b
g
b
j
h
c
g
k
e
e
e
j
e
b
e
k
c
d
e
b
e
d
h
d
k
j
e
j
e
g
i
g
b
k
d
h
i
d
e
j
c
d
j
e
b
i
j
h
c
d
j
b
d
k
k
c
f
h
e
c
f
f
e
b
b
f
j
b
c
j
g
e
i
h
c
f
i
f
h
e
k
k
j
j
i
h
b
c
j
e
g
d
g
g
g
d
h
h
d
b
d
k
d
b
b
i
d
c
f
e
k
b
j
j
i
f
c
d
e
c
g
h
h
e
f
f
g
k
d
h
d
g
g
j
i
h
i
g
g
d
k
c
g
i
i
j
f
d
k
k
h
g
h
g
i
k
g
h
f
k
i
j
e
e
k
d
k
k
d
c
d
g
d
f
e
g
d
f
f
c
c
d
d
f
h
i
b
k
h
d
b
d
k
e
i
d
c
j
i
i
h
i
j
h
b
h
i
j
h
k
k
k
d
i
h
i
d
c
i
i
b
e
d
j
d
h
j
j
b
i
h
e
h
e
i
c
c
j
d
k
c
h
g
i
c
g
f
i
f
h
k
b
e
g
g
c
k
j
c
h
k
f
e
j
k
b
g
e
c
j
c
g
d
i
g
k
c
j
j
g
d
d
c
k
k
g
f
f
h
g
d
k
i
f
j
h
g
c
j
h
j
e
f
d
h
j
i
e
d
c
f
j
b
h
i
b
d
f
b
e
b
j
h
d
i
i
h
c
g
h
f
c
i
h
b
b
e
b
i
d
g
d
k
j
e
k
c
b
f
e
f
f
f
e
e
g
i
g
d
d
e
k
b
b
e
b
h
i
d
k
e
d
k
c
f
h
i
k
c
e
b
b
h
h
h
c
h
k
k
b
j
f
g
b
h
d
e
f
j
h
i
h
c
f
g
e
e
j
d
i
c
h
c
b
c
j
e
k
k
f
b
d
i
k
i
d
k
h
b
g
b
k
e
j
f
k
k
d
g
h
k
d
b
k
k
j
h
c
k
k
i
k
b
j
h
g
c
i
d
k
j
j
f
b
k
i
i
k
e
h
b
j
c
e
h
i
h
f
g
i
f
i
f
k
g
d
g
h
i
j
g
k
e
f
k
g
b
b
h
e
c
j
e
d
f
d
i
j
e
h
k
c
h
h
j
e
h
j
j
f
b
i
k
b
h
g
h
c
c
k
i
k
g
c
d
i
f
j
f
f
k
d
k
h
b
c
e
g
i
f
c
i
g
j
i
i
b
h
b
h
d
b
i
e
j
c
h
d
d
c
h
d
h
f
e
c
j
i
k
b
j
c
g
i
b
d
f
c
j
g
i
b
d
i
g
e
b
j
c
d
k
d
h
e
e
g
j
e
i
k
d
k
e
b
d
g
g
e
d
j
d
e
c
g
g
h
k
e
e
d
e
j
i
d
h
k
j
f
k
c
g
c
g
h
k
k
k
j
d
g
i
h
e
d
d
d
d
b
j
i
i
k
f
h
d
d
i
k
c
i
b
i
e
b
e
c
c
f
h
j
g
b
f
i
d
k
d
h
d
j
e
j
f
g
j
d
e
c
f
h
b
b
d
c
d
b
c
e
f
i
i
h
k
d
c
j
k
c
j
e
d
d
g
i
c
c
c
f
i
e
c
e
d
g
h
k
j
j
i
d
c
c
i
i
e
h
f
j
g
c
j
k
g
b
h
h
b
j
g
k
j
i
e
e
g
c
k
g
g
i
i
g
b
e
i
e
i
f
d
e
j
b
g
d
k
h
j
e
i
d
e
c
i
h
i
i
g
h
j
g
g
i
b
j
k
c
k
e
e
c
d
k
j
j
f
d
d
i
g
h
d
b
d
k
d
b
k
f
k
g
k
j
f
k
e
j
h
i
k
d
g
d
h
b
f
b
h
k
k
k
d
g
d
e
e
j
j
e
i
f
d
c
e
d
k
f
j
i
c
g
j
d
j
k
e
b
e
c
b
j
k
j
d
e
h
f
k
c
i
f
j
f
c
h
e
k
c
g
e
k
i
d
i
b
d
k
g
b
e
e
f
c
d
b
d
j
j
i
i
g
b
j
d
e
k
h
i
k
k
b
d
i
f
i
f
c
h
g
f
e
c
h
g
e
c
e
j
d
j
d
j
j
b
g
k
e
c
i
g
j
b
g
f
c
h
e
i
g
e
d
c
i
g
g
i
d
b
c
k
j
k
b
h
j
f
k
b
c
c
f
d
k
h
i
g
c
c
f
k
b
h
g
d
e
k
i
f
g
i
g
c
k
j
f
h
g
j
c
h
b
e
i
e
k
i
e
f
h
d
j
h
j
e
b
b
i
b
f
h
c
j
j
g
g
j
b
k
e
e
g
k
d
k
h
b
h
c
c
b
e
g
f
j
c
b
d
b
j
f
h
e
e
j
b
i
h
i
j
j
d
b
f
d
j
d
h
g
j
d
h
g
b
e
h
h
e
b
g
k
b
g
c
d
c
g
g
e
c
g
j
c
b
f
k
k
b
g
c
h
h
c
j
i
d
e
k
i
k
f
i
d
j
h
e
b
c
i
g
j
h
k
h
i
k
b
g
f
f
k
g
e
e
i
d
b
e
f
b
k
i
h
c
j
h
e
i
b
h
k
f
b
k
b
i
j
k
h
g
f
c
f
g
k
c
f
j
f
h
d
d
h
d
e
g
f
h
k
e
h
e
c
d
i
f
e
d
e
i
e
e
e
g
d
k
c
g
g
e
g
g
j
h
d
i
e
g
b
k
h
k
j
b
d
g
h
h
i
e
b
h
c
c
b
g
e
d
b
c
b
g
f
k
h
b
i
k
i
h
g
i
j
d
g
i
j
f
k
j
i
g
d
f
h
f
c
e
i
h
h
i
f
d
j
k
f
d
e
g
j
f
c
h
g
h
g
g
c
f
e
c
c
f
i
i
e
h
g
f
d
c
b
c
d
e
d
f
h
d
g
f
k
j
i
j
k
b
e
g
b
h
d
j
e
d
d
i
b
b
c
b
j
h
i
g
e
g
d
d
c
h
d
f
j
d
i
h
e
h
e
b
d
h
f
i
b
c
e
d
i
d
b
e
e
f
g
k
g
k
g
k
b
b
h
b
f
g
f
k
g
k
j
i
b
h
h
i
g
i
f
h
i
g
d
d
g
b
h
j
e
d
b
d
d
e
e
c
h
d
c
k
i
e
j
c
g
d
j
h
g
j
g
d
e
f
k
j
b
f
f
g
j
f
f
f
i
i
b
g
i
c
d
e
j
d
d
b
f
h
h
b
c
f
j
g
d
e
e
i
i
g
i
h
k
e
j
b
d
h
c
g
e
b
e
c
h
e
h
e
d
e
d
h
k
k
c
c
d
k
i
k
d
i
h
k
d
b
c
c
i
k
k
b
k
h
c
g
d
h
i
c
c
i
h
h
k
b
d
k
f
f
g
h
b
h
i
e
j
e
g
k
j
g
f
h
g
h
c
g
e
f
j
h
k
f
b
g
j
f
e
i
k
h
e
i
i
d
g
i
j
d
b
g
g
h
j
h
d
k
c
e
h
b
c
c
d
h
f
g
e
f
c
i
d
k
f
e
j
f
f
f
j
i
d
i
c
j
f
j
d
d
b
e
b
g
h
c
d
c
f
h
k
e
g
j
k
k
i
j
i
k
h
h
e
j
b
e
h
j
e
k
b
e
i
h
c
i
c
d
b
c
d
k
g
j
i
j
k
c
j
d
b
d
b
j
d
f
d
b
e
j
f
j
e
b
d
g
g
c
f
d
d
f
e
d
f
k
e
i
d
c
f
j
k
e
i
h
g
i
b
f
b
c
e
g
c
e
g
i
j
b
k
k
d
d
d
f
e
i
d
h
c
h
f
e
i
f
c
h
f
h
e
c
k
d
k
f
e
j
k
g
i
h
b
g
c
f
g
c
h
j
h
j
k
c
j
i
j
b
j
j
e
d
e
d
i
b
d
g
e
h
g
d
f
h
j
c
h
e
k
j
i
k
b
h
f
d
h
g
e
i
c
c
c
g
d
d
i
h
i
i
h
h
i
k
h
j
f
b
e
i
e
c
k
k
g
i
f
h
k
h
f
i
d
j
d
j
f
c
e
e
e
d
b
g
j
i
i
g
g
h
f
k
d
c
j
c
c
i
k
b
j
d
e
c
c
b
c
b
b
k
h
b
b
c
d
e
e
g
k
j
i
i
i
j
b
e
f
c
f
f
e
c
i
b
c
h
g
c
h
e
k
i
c
f
e
b
g
b
i
f
g
j
i
k
k
j
d
i
c
i
e
j
k
g
j
b
i
k
d
k
h
i
d
d
k
i
b
d
c
g
i
i
b
k
h
d
d
j
e
e
k
b
b
c
g
k
g
h
c
c
g
k
f
h
k
d
e
f
d
h
g
j
b
e
f
j
h
g
i
c
c
b
d
c
b
e
b
b
f
i
f
g
j
b
d
k
f
c
d
e
e
k
h
j
e
h
k
i
h
b
b
j
d
h
k
k
c
d
e
i
c
f
f
j
d
e
h
c
i
h
j
d
c
c
c
h
g
c
h
f
g
b
i
c
g
j
d
c
h
j
i
h
b
e
k
i
h
i
f
b
g
b
c
f
j
d
e
c
h
b
i
j
j
b
i
d
j
d
k
j
k
e
k
g
b
g
i
h
k
i
h
c
j
h
c
g
h
i
f
f
g
h
d
f
b
g
k
f
e
e
c
f
k
c
e
e
b
d
i
g
h
g
c
f
f
f
i
d
g
h
c
h
e
i
b
f
f
f
k
j
h
e
h
i
j
f
b
h
h
e
f
f
c
k
i
f
j
i
j
g
f
j
k
h
d
h
c
b
c
f
k
i
e
h
g
g
k
c
k
f
b
b
i
b
j
e
i
d
j
e
d
j
i
i
b
h
f
k
e
j
k
h
i
f
e
d
e
k
e
i
g
f
c
i
b
j
h
j
b
d
j
b
j
h
e
e
e
i
f
g
g
h
i
c
c
d
c
e
b
h
b
d
c
h
c
f
b
k
i
d
f
f
b
i
c
j
c
e
e
k
e
k
g
g
c
d
e
e
j
h
c
c
f
h
g
i
c
f
c
e
h
h
e
g
c
j
d
f
g
c
g
f
k
j
b
j
e
e
f
d
c
c
g
g
g
b
h
h
f
g
k
i
k
f
k
f
c
k
e
k
f
g
i
e
g
f
j
e
j
c
c
k
e
g
i
c
e
i
g
e
f
i
i
i
c
k
c
k
b
f
e
k
h
f
j
i
k
d
g
i
g
d
b
c
d
e
e
d
d
e
g
h
g
i
b
h
g
h
e
k
c
h
h
e
i
j
b
k
i
e
h
e
e
g
b
k
d
b
j
j
d
c
c
g
d
d
c
e
k
e
j
c
f
h
k
d
d
j
h
b
j
j
j
e
c
b
c
j
e
k
k
k
d
c
c
k
b
g
d
h
f
i
h
h
g
h
f
b
e
i
d
e
b
h
h
i
d
j
k
d
d
f
h
i
k
k
d
j
i
e
i
d
i
i
e
d
e
g
i
g
e
k
h
k
d
j
f
c
c
d
g
g
k
h
i
b
j
i
i
d
b
i
h
f
e
h
d
k
i
b
c
i
k
c
i
b
h
j
i
c
c
h
b
b
d
g
f
f
d
g
k
k
h
d
d
d
g
f
g
f
k
c
b
i
b
k
j
k
d
h
i
j
c
g
b
e
f
d
b
d
f
i
e
c
g
g
g
h
i
i
k
k
j
d
f
c
d
d
c
k
c
g
b
e
b
j
j
i
f
e
h
h
d
h
h
j
i
k
h
c
i
k
k
c
i
b
b
h
k
j
e
e
i
d
h
e
g
c
h
k
i
h
i
f
i
k
j
k
d
c
g
d
g
i
h
e
j
j
g
d
d
d
d
e
d
h
k
e
d
g
c
c
e
i
d
g
f
c
b
h
c
b
c
c
i
j
b
d
g
k
f
e
g
e
i
d
d
f
c
i
e
d
j
b
k
d
f
b
k
e
g
k
h
b
f
g
k
e
g
c
c
h
h
e
g
j
b
f
b
e
d
f
c
d
k
b
g
e
d
e
f
d
k
k
c
c
e
f
f
c
g
i
d
k
d
d
b
b
h
e
f
g
e
g
g
d
d
j
c
g
i
e
d
d
b
i
k
d
g
b
f
h
k
e
d
i
c
b
f
j
b
c
j
j
h
e
f
h
e
i
b
j
j
i
b
e
h
f
e
c
j
h
j
c
g
i
c
b
f
b
e
k
b
d
c
c
b
e
g
b
h
g
c
e
i
b
b
d
k
c
c
i
k
e
g
b
h
e
d
g
j
j
j
g
h
c
c
j
g
h
d
f
b
h
k
b
j
g
g
d
e
b
h
f
g
i
d
c
e
j
i
k
e
g
c
f
c
b
g
j
k
c
j
i
c
i
h
h
f
b
c
d
e
d
i
j
e
g
e
c
f
i
c
h
i
b
k
c
j
h
g
e
c
f
h
k
g
e
i
b
k
i
c
i
i
b
b
d
j
j
c
k
g
j
i
c
i
j
b
j
e
c
c
j
k
b
g
e
d
e
h
j
e
i
i
b
g
f
g
c
h
j
k
h
h
f
d
j
b
i
j
e
g
b
e
e
c
c
d
f
k
k
b
f
c
i
g
b
j
i
k
e
c
d
f
f
j
g
c
i
f
g
k
k
f
k
f
d
f
g
f
h
e
d
g
e
c
f
j
c
b
d
f
e
j
h
h
i
h
h
d
d
f
g
e
j
d
c
i
d
g
c
h
h
g
g
k
j
j
b
i
h
i
c
k
i
c
f
c
k
e
f
d
b
h
c
c
i
e
c
f
g
b
d
c
e
g
i
j
b
j
j
b
c
h
g
h
h
e
j
d
i
b
g
b
c
f
c
b
b
f
h
c
i
f
d
k
g
i
g
f
c
g
g
i
c
i
k
j
g
i
g
f
k
f
k
f
f
g
f
b
g
e
k
d
h
f
c
c
e
i
h
f
k
g
k
c
h
d
f
i
e
i
d
h
e
j
k
i
e
d
g
d
b
b
j
e
h
e
h
e
b
e
h
b
f
c
e
k
f
g
f
i
e
e
f
k
k
g
h
h
g
k
j
e
i
i
h
d
f
h
e
e
b
f
g
d
d
i
k
c
j
d
d
d
b
j
d
b
c
c
h
h
g
k
b
c
h
k
b
g
c
i
f
e
i
d
i
f
c
h
h
b
j
c
c
k
h
e
g
g
c
f
i
i
g
i
f
k
c
e
h
c
d
k
d
i
j
c
g
h
h
c
e
e
b
c
h
e
f
i
d
i
f
g
i
f
j
c
d
d
h
i
k
j
h
h
e
g
d
i
d
g
b
e
c
k
h
g
j
b
f
e
g
b
g
e
f
k
g
j
b
c
i
c
i
i
g
k
g
i
i
i
k
d
j
h
i
c
i
h
d
b
i
k
k
g
f
f
h
k
h
h
i
g
c
i
g
j
h
c
c
b
f
e
d
h
b
j
h
h
h
c
e
k
k
f
d
k
i
e
d
j
k
j
g
d
i
d
k
e
b
f
d
b
g
f
e
j
j
f
c
f
i
i
f
j
c
j
f
d
i
b
k
e
f
e
i
b
f
b
j
e
c
i
i
b
f
i
i
k
c
b
d
h
i
h
k
i
h
j
j
i
f
d
j
b
h
d
b
c
h
c
h
d
i
e
f
f
g
g
g
f
k
k
h
b
c
j
e
h
d
e
j
b
d
e
g
k
d
f
e
b
e
g
d
e
d
b
g
b
h
k
g
e
k
j
d
g
b
k
c
i
d
b
f
d
g
g
d
i
g
b
j
g
c
g
e
b
b
k
g
k
e
i
h
e
i
k
k
f
c
f
i
c
b
g
h
e
b
i
h
f
b
h
c
b
g
g
h
b
d
b
c
i
i
d
i
i
k
i
c
d
b
c
h
f
g
h
k
e
e
g
i
k
k
d
i
k
e
e
i
j
e
k
c
b
i
h
k
c
k
d
g
b
f
c
e
j
e
j
i
k
e
c
f
h
d
g
j
k
d
j
h
b
k
i
c
c
h
k
k
c
c
b
j
k
e
h
e
i
k
i
b
g
c
f
j
e
c
e
g
g
e
k
k
g
f
b
f
d
h
h
k
h
i
c
f
g
j
c
d
k
g
j
k
h
j
d
h
i
f
c
g
k
i
b
g
c
c
h
j
f
e
b
i
d
i
j
f
j
k
c
f
j
i
g
k
d
j
i
d
h
k
j
f
b
i
g
d
i
d
c
d
g
f
k
g
k
d
b
j
c
d
g
i
d
e
d
g
g
f
d
d
k
f
i
f
c
i
e
i
e
k
e
e
c
g
d
b
g
c
b
d
i
b
f
h
k
h
f
j
e
d
e
k
j
f
i
i
h
e
b
b
b
c
i
e
j
g
d
h
d
c
h
c
j
c
b
h
j
f
e
k
d
b
h
c
b
e
k
b
d
b
b
k
k
i
j
d
k
g
b
c
k
k
b
j
g
b
i
e
i
h
d
g
i
h
d
d
b
h
b
c
d
k
e
e
d
g
d
b
h
j
e
i
c
b
j
c
e
j
e
g
i
k
e
b
d
b
c
k
j
g
e
c
b
i
i
k
e
d
e
e
k
g
i
f
j
b
e
b
d
g
f
i
k
k
j
i
j
f
i
g
k
d
d
g
f
j
h
k
h
d
f
g
g
d
f
e
g
c
k
j
e
f
e
h
g
c
k
i
g
c
g
b
f
h
k
j
h
e
d
b
g
d
b
i
c
f
d
g
f
h
i
k
e
g
d
k
i
k
g
h
c
f
f
i
c
j
k
b
k
h
f
d
g
d
f
k
e
b
i
d
e
i
d
d
k
i
g
e
k
h
j
d
e
b
c
g
d
g
b
d
d
d
h
f
e
j
j
h
d
j
e
f
g
d
e
j
f
e
k
f
f
f
i
h
f
g
b
i
h
f
k
b
h
b
e
i
h
j
f
g
c
j
b
f
k
d
g
k
d
d
d
c
j
c
d
b
k
j
d
e
j
c
d
b
h
g
d
k
c
g
f
i
k
d
f
e
c
f
g
e
e
c
h
b
h
c
d
d
j
k
h
j
j
d
f
c
j
k
e
d
i
f
b
c
e
e
b
e
k
f
i
h
j
e
e
k
f
k
g
j
c
b
h
b
c
b
c
i
f
d
h
f
f
j
c
h
b
h
k
h
d
b
i
d
e
i
j
g
c
g
k
e
g
c
g
f
b
i
i
e
j
i
h
i
d
k
k
h
g
h
b
g
b
g
k
d
g
k
j
i
e
d
d
i
i
k
d
b
d
h
j
h
j
h
i
c
b
i
e
f
k
b
h
b
e
e
k
g
h
b
c
e
b
j
c
b
c
j
e
f
c
h
h
i
f
i
i
g
d
d
d
c
g
j
c
h
f
i
i
b
d
b
k
b
d
g
d
k
b
h
c
f
g
j
g
j
b
f
g
d
k
d
h
g
c
b
f
f
d
i
b
i
b
e
f
i
i
j
d
i
f
b
i
h
k
b
j
h
g
j
e
d
g
h
d
d
f
h
c
k
e
f
i
e
e
k
d
d
k
i
h
j
e
b
j
c
g
j
j
k
j
g
e
h
f
j
k
f
d
c
h
c
i
j
f
e
f
j
k
g
j
f
k
b
f
i
j
f
k
b
g
i
e
k
e
g
c
h
f
e
i
j
k
h
d
h
k
k
c
e
f
e
i
j
i
c
d
g
k
i
e
k
e
g
j
b
j
b
b
c
f
j
d
d
i
f
b
h
h
d
i
f
k
i
b
k
e
i
e
i
k
e
f
c
c
k
d
e
k
f
k
b
h
h
j
d
g
e
b
d
f
i
h
j
h
f
c
d
c
k
k
i
f
h
j
i
c
j
c
d
j
i
g
b
h
k
f
h
f
c
h
c
g
e
h
j
c
f
g
i
f
k
k
f
h
b
e
b
c
f
c
g
i
d
h
i
j
b
i
e
e
i
j
h
i
b
i
g
b
i
j
g
i
g
e
g
g
j
f
b
f
c
d
i
e
c
k
h
k
k
e
g
i
c
d
k
c
b
g
f
e
d
h
f
k
c
j
k
i
g
f
i
h
g
i
c
e
g
h
b
f
c
g
g
k
b
j
e
g
c
i
j
c
k
j
f
g
d
k
j
g
f
k
k
j
i
g
g
i
i
g
e
g
e
g
i
j
h
h
h
j
b
f
g
j
j
b
b
g
j
b
f
c
c
c
f
g
j
f
d
h
b
k
g
i
h
g
h
c
g
i
b
i
j
b
d
j
j
d
b
k
j
f
c
d
j
b
k
k
g
j
h
g
h
j
i
f
b
c
b
d
k
b
c
c
b
e
k
j
c
e
i
b
j
k
f
d
d
k
i
f
e
g
c
k
j
h
j
i
e
e
h
d
i
c
j
g
c
g
f
k
h
g
i
h
e
h
b
f
h
j
f
j
f
f
e
h
k
h
i
b
b
e
h
i
k
b
h
j
c
j
e
d
e
j
b
i
e
c
h
h
i
f
d
i
c
i
d
h
c
d
b
f
f
i
k
f
f
d
b
e
c
c
i
k
f
g
b
e
k
k
d
f
i
j
e
j
k
e
g
c
k
k
g
b
h
h
j
e
f
c
f
b
h
f
c
i
b
j
g
d
i
e
k
b
f
i
k
f
h
c
e
g
h
e
f
b
f
b
j
e
i
f
c
k
e
c
c
d
c
c
j
d
d
g
j
g
d
g
j
e
e
f
j
e
f
b
e
e
f
i
f
c
h
e
e
b
d
b
i
f
j
j
e
b
g
g
g
h
i
c
b
i
f
j
f
f
j
j
f
b
k
f
d
k
k
b
b
d
f
c
f
g
e
g
b
g
i
c
e
g
f
k
d
d
g
e
e
j
d
g
b
c
c
g
d
i
b
k
d
e
g
i
i
k
i
j
f
e
h
b
k
g
c
b
c
j
f
d
h
h
b
k
j
f
j
g
d
d
h
b
h
f
e
i
e
b
d
d
c
k
i
i
c
e
c
b
c
e
e
c
h
f
g
b
d
j
j
f
f
j
d
c
c
k
j
b
b
i
k
i
e
c
c
g
j
f
d
c
j
g
i
c
g
h
e
k
i
b
e
d
k
h
h
f
e
j
e
b
k
j
c
k
g
e
c
f
c
b
b
d
e
b
e
d
c
d
i
h
d
b
i
i
e
f
d
i
h
i
f
f
k
i
k
k
i
c
g
h
d
b
d
h
b
h
j
e
k
b
e
g
d
e
k
h
b
i
k
g
g
e
j
e
f
h
h
h
d
j
i
i
f
c
e
d
b
i
i
d
j
g
g
i
f
h
g
e
h
j
d
i
e
c
j
k
i
c
g
c
h
j
c
f
e
g
d
g
d
d
e
d
i
k
i
h
k
h
c
b
c
f
k
k
c
i
g
b
g
k
h
f
c
h
b
d
f
d
f
i
f
e
f
j
j
k
i
i
e
j
k
b
e
e
g
d
c
h
j
h
d
d
g
b
d
e
c
e
g
b
j
g
h
i
c
b
c
e
i
f
g
j
b
c
e
j
c
e
c
e
f
b
k
b
d
k
i
e
b
j
g
e
j
b
e
h
g
c
f
d
g
e
k
c
b
d
f
j
b
h
c
b
g
k
e
i
c
i
k
j
e
i
g
d
h
d
c
i
d
i
j
k
g
d
c
b
h
i
k
d
e
k
j
f
h
d
i
b
h
j
f
b
c
i
i
g
h
f
f
c
c
h
d
h
e
j
d
b
c
e
f
e
g
i
j
g
e
e
c
h
b
h
f
j
e
f
f
j
j
h
h
d
d
b
e
d
h
j
j
f
g
b
g
e
h
b
i
j
h
k
c
f
h
k
c
g
h
e
c
e
i
g
j
c
j
h
c
e
k
d
j
g
i
b
k
k
c
e
k
e
j
k
c
j
i
e
h
b
h
h
e
b
g
c
e
d
h
d
i
d
j
k
e
h
d
d
h
j
e
b
i
f
d
h
j
c
j
h
k
e
f
e
j
f
h
c
b
f
f
c
e
b
b
c
c
j
h
e
j
d
g
i
e
b
i
h
k
k
e
i
i
e
b
f
h
k
d
b
i
c
e
i
d
d
c
k
d
e
j
k
g
c
k
k
i
f
d
b
h
c
g
e
c
b
e
h
i
h
k
g
f
b
j
c
c
f
j
f
c
c
j
g
d
b
d
e
b
e
c
b
h
g
k
i
e
b
j
f
d
d
j
d
h
g
g
e
f
h
j
k
i
g
e
c
f
e
e
h
c
d
k
e
f
g
b
i
d
e
i
e
f
d
g
b
b
e
e
b
c
i
j
b
b
e
i
b
h
c
c
i
h
g
f
i
d
g
c
i
k
h
d
f
k
h
c
h
k
f
g
k
k
b
g
j
j
h
d
k
i
c
h
g
